#define WIN32_LEAN_AND_MEAN

#include <windows.h>

#include "resource.h"

#include "ximage.h"

HINSTANCE hInst;

HWND      hWnd;
HWND      hStaticImage;
HBITMAP   hBitmap;
CxImage   imagePNG;

void drawBitmapToIndicateStatic(HBITMAP *pHBitmap)
{
    HWND    hStaticControl = GetDlgItem(hWnd, IDC_STATIC_IMAGE);
    HDC     hStaticDC      = GetDC(hStaticControl);
    HDC     hTempDC;
    HBITMAP hOldBitmap;
    RECT    aRect;

    GetWindowRect(hWnd,&aRect);

    hTempDC = CreateCompatibleDC(GetDC(0));
    hOldBitmap = (HBITMAP)SelectObject(hTempDC, *pHBitmap);

    BitBlt(hStaticDC, 0, 0, aRect.right - aRect.left, aRect.bottom - aRect.top, hTempDC, 0, 0, SRCCOPY);

    SelectObject(hTempDC, hOldBitmap);
    DeleteObject(hTempDC);
    DeleteObject(hStaticDC);

    SendDlgItemMessage(hWnd, IDC_STATIC_IMAGE, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)(HBITMAP)*pHBitmap);
}

BOOL CALLBACK DialogProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch(uMsg)
    {
        case WM_INITDIALOG:
            hWnd = hwndDlg;
            hStaticImage = GetDlgItem(hwndDlg, IDC_STATIC_IMAGE);
            imagePNG.Load(TEXT("test.png"), CXIMAGE_FORMAT_PNG);
            hBitmap = imagePNG.MakeBitmap(GetDC(hStaticImage));
            drawBitmapToIndicateStatic(&hBitmap);
            return TRUE;

        case WM_CLOSE:
            EndDialog(hwndDlg, 0);
            return TRUE;

        case WM_COMMAND:
            switch(LOWORD(wParam))
            {
                // control ..
            }
    }

    return FALSE;
}


int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd)
{
    hInst = hInstance;

    // The user interface is a modal dialog box
    return DialogBox(hInstance, MAKEINTRESOURCE(DLG_MAIN), NULL, (DLGPROC)DialogProc);
}
